// bmedit.h

#include <commctrl.h>
#include "stdio.h"

#define ID_LIST 100
#define ID_STATIC 101
#define ID_LISTL 102
#define ID_STATICL 103
#define ID_STATUSBAR 104
#define ID_BUTTON 105
#define ID_SEARCH 106
#define ID_DIRL 107
#define ID_EDIT 108
#define ID_UP 109
#define ID_DOWN 110

#define CONTEXT_GETFILE 100
#define CONTEXT_CONNECT 200
#define CONTEXT_PUTFILE 300
#define MAX_INFO MAX_PATH

#define ASCII 1
#define BINARY 0

#define MAX_URL 60000

#ifdef UNICODE
#define  clipformat  CF_UNICODETEXT
#else 
#define  clipformat  CF_TEXT
#endif


typedef struct _tagFNAME{
    char szFName[MAX_PATH];
    char szLocalFileName[MAX_URL];
} FNAME;

typedef struct _tagHWNDSET{
    HWND hwnd1;
    HWND hwnd2;
    HIMAGELIST hImage;

} HWNDSET;


typedef struct _tagSTATUSCALLBACK
{
    HWND hwndStatus;
    DWORD dwFrom;
} STATUSCALLBACK;
    

class urldata
{
private:
	char url[MAX_URL+1];
	char title[MAX_URL+1];
public:
	void setline(char*data);
	char* geturl(){return url;};
	char* gettitle(){return title;};
};


_extern HINSTANCE hInst;

_extern int itemmode;
#define FAVFILE_MODE 7
#define BROWSER_MODE 6
#define SEARCH_MODE 5
#define MEMO_MODE 4
#define FOLDER_MODE 3
#define MAIL_MODE 2
#define URL_MODE 1
#define EXPLORER_MODE 0

int CALLBACK MyCompProc(LPARAM, LPARAM, LPARAM);
ATOM InitApp(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
int SetMyLocalDir(HWND, HWND, HWND, HIMAGELIST);
void ChangeLocalDrive(HWND, HWND, HWND, HIMAGELIST);
HWND MakeMyList(HWND);

//ǉ
void settitle(HWND &hWnd,BOOL);
void resettitle(HWND &hWnd);
void settransfermode();
BOOL MyAddUrl(HWND);
void MyCreatDir(HWND, HWND, HWND);
void MyCreatFile(HWND, HWND, HWND);
void MyCreatBlankFile();
void MyDelFile(HWND);
void MyRemoveDir(HWND);
void settransfermode(int);

void addlistitem(char *name,int num);
int SetFolderList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char*,int);
int SetUrlList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char*,int);
int SetMemoList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char*,int);
int SetSearchList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char*,int);
int SetMailAddressList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char*);

