
#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <windows.h>
#include <iostream.h>
#include <fstream.h>
#include <wininet.h>
#include <windowsx.h>
/*
*/
#include <commctrl.h>
#include "hwnd.h"
#include "resource.h"
#include "bmedit.h"
#include "listview.h"
#include "initial.h"
#include "browse.h"
#include "file.h"
#include "main.h"


char cdir[MAX_PATH];
char buffer[MAX_URL+1];
char initfile[MAX_PATH]="bmedit.ini";
char mainbrowserfile[MAX_PATH]="mainbrowser.ini";
//char logfile[MAX_PATH]="ftplog.txt";
char dirfile[MAX_PATH]="directory.txt";
char hisfile[MAX_PATH]="history.txt";
char winhisfile[MAX_PATH]="window_his.txt";
char urlfile[MAX_PATH]="BookmarkUrl.txt";
char searchfile[MAX_PATH]="search.txt";
char urltimefile[MAX_PATH]="BookmarkTime.txt";
char treefile[MAX_PATH]="bmtree.txt";
char bmtmpfile[MAX_PATH]="bmtmp.txt";
char helpfile[MAX_PATH]="readme.txt";
char clipfile[MAX_PATH]="bmclip.txt";

char initdirfile[MAX_PATH];
char mainbrowserdirfile[MAX_PATH];
//char listdirfile[MAX_PATH];
char dirdirfile[MAX_PATH];
char hisdirfile[MAX_PATH];
char winhisdirfile[MAX_PATH];
char urldirfile[MAX_PATH];
char searchdirfile[MAX_PATH];
char urltimedirfile[MAX_PATH];
char treedirfile[MAX_PATH];
char bmtmpdirfile[MAX_PATH];
char helpdirfile[MAX_PATH];
char clipdirfile[MAX_PATH];


char keywindow[]="setting";
char keybrowser[]="browser";
char keybrowsername[]="browser_name";
char keysoft[]="soft";
char keysoftname[]="soft_name";
char keyffile[]="faveritefile";
char keyffilename[]="faveritefile_name";
char keydirlocal[]="dir local";
char keydirremote[]="dir remote";
char keyfixedurl[]="fixed url";
char keyfixedbrowser[]="fixed browser";
char keyfasturl[]="fast url";
int localdirnum;
int remotedirnum;
#define UrlEndDelimMax 50
char UrlEndDelim[UrlEndDelimMax+2]="\r \"\t\'>),\n";//URL I̕



#define MAX_NAME 50
#define autofilesavemax 10
const int namenummax=50;
char namelist[namenummax][MAX_NAME];
int timeitemsize=14;
int readksize;
const int numlen=10;
const int initcountmax=10000;

struct directory
{
	int num;
	char dir[MAX_PATH];
} stockdir;

int seed;
int sessionNum;

#ifdef NDEBUG
	ofstream lo("log.txt");
#endif

void log(char *d)
{
#ifdef NDEBUG
	lo<<d<<endl;
#endif
}


void setdirfile(char *df,char *f);
void addfolder(char *folder, char *file);


void clip(char *dat)
{
	ofstream ou(clipdirfile,ios::ate);
	ou<<dat<<endl;
}

//@Nbvt@Ĉ܂܃tH_t@CɃRs[
void copyclip(char* folder)
{
	char fname[MAX_PATH+1];
	if(strlen(folder)>0) 
	{
		setdirfile(fname,folder);
	}
	else strcpy(fname,urldirfile);
	ifstream in(clipdirfile);
	ofstream ou(fname, ios::ate);
	if(ou) addfolder(folder,urldirfile);
	while(!in.eof())
	{
		memset(buffer,0,sizeof(buffer));
		in>>buffer;
		if(buffer[0]!=0) ou<<buffer<<endl;
	}
	in.close();
	in.open(clipdirfile, ios::trunc);
}


// f[^邩sƂf[^Ƃ
//@VKȂɒǉ
void savedata(char *file, char *data)
{
	if(strlen(data)==0) return;
	BOOL flag=FALSE;
	ifstream in(file);
	while(!in.eof())
	{
		memset(buffer,0,MAX_URL+1);
		in.getline(buffer,MAX_URL);
		if(in.gcount()==0) break;
		if(strcmp(data,buffer)==0) 
		{
			flag=TRUE;
			break;
		}
	}
	in.close();
	if(flag==FALSE)
	{
		ofstream ou(file,ios::ate);
		ou<<data<<endl;
	}
}


// ----------------------------------
// ȂtH_`FbNċL^

void savedirlocal(char *dir)
{
	savedata(dirdirfile, dir);
}

// ۑ

void savesearch(char *word)
{
	savedata(searchdirfile, word);
}


//@url fileɂłɂ邩`FbN
// s܂ǂ

BOOL CheckExistInUrl(char *urldata)
{
	BOOL ans=FALSE;
	char buffer[1000];
	ifstream in(urldirfile);
	while(1)
	{
		in.getline(buffer,1000);
		if(in.gcount()==0) break;
		if(strstr(buffer,urldata)!=NULL) 
		{
			ans =TRUE;
			break;
		}
		if(in.eof()) break;
	}
	return ans;
}

char* getinitdir()
{
	return cdir;
}


//url fileɒǉA
//url	title	caption

void addurl(ofstream &u, char* url,char* title,char* caption,char*seperater)
{
	char sep[15];
	if(strstr(currentfile,".txt")==NULL) return;
	wsprintf(sep,"%s",seperater);
	if(strlen(sep)==0) strcpy(sep,"\t");
	if(strlen(url)>0) u<<url<<sep;
	if(strlen(title)>0) u<<title<<sep;
	if(strlen(caption)>0) u<<caption;
	if(strlen(url)>0 || strlen(title)>0 || strlen(caption)>0)
	{
		u<<endl;
		setvisittime();
	}
}

//Wt@Cɒǉ
void addurl(char* url,char* title,char* caption,char*seperater)
{
	ofstream u(urldirfile,ios::ate);
	addurl(u,url,title,caption,seperater);
}

BOOL existfolder(char *folder, char *file)
{
	BOOL ans=FALSE;
	char foldername[MAX_PATH+10];
	wsprintf(foldername,"folder:%s",folder);
	ifstream in(file,ios::nocreate);
	if (!in) return ans;
	while(!in.eof())
	{
		in.getline(buffer,1000,'\n');
		if(strstr(buffer,foldername)!=NULL)
		{
			ans =TRUE;
			break;
		}
	}
	return ans;
}

void addfolder(char *folder, char *file)
{
	if(existfolder(folder,file)) return;
	ofstream u(file,ios::ate);
	u<<"folder:"<<folder<<endl;
}

//tH_t@Cɒǉ
BOOL getfolderfullpath(char *folderpath,char *folder)
{
	if(strlen(folder)==0) return FALSE;
	wsprintf(folderpath,"%s\\%s",cdir,folder);
	addfolder(folder,urldirfile);
	return TRUE;
}

void addurl(char *folder,char* url,char* title,char* caption,char*seperater)
{
	char folderpath[MAX_PATH];
	if(strlen(folder)>0) 
	{
		getfolderfullpath(folderpath,folder);
	}
	else
	{
		strcpy(folderpath,urldirfile);
	}
	ofstream u(folderpath,ios::ate);
	addurl(u,url,title,caption,seperater);
}

// dȂŒǉ
void Addhistory(char *dat)
{
	savedata(hisdirfile, dat);
}

// 
void AddWinhistory(char *dat)
{
	savedata(winhisdirfile, dat);
}

void resetgetnexturl()
{
}

char* geturlfile()
{
	return urldirfile;
}


char* gethisfile()
{
	return hisdirfile;
}

char* getclipfile()
{
	return clipdirfile;
}

char* getsearchfile()
{
	return searchdirfile;
}

char* gettimefile()
{
	return urltimedirfile;
}
char* gethelpfile()
{
	return helpdirfile;
}

// Lite uEŨubN}[Nt@Cǂ`FbN

BOOL checklitebrowser(char *file)
{
	ifstream in(file);
	char buf[10];
	in.get(buf,8);
	if(strncmp(buf,"Lite",4)==0) return TRUE;
	else return FALSE;
}

BOOL urlfromfile(char* file)
{
	char* p;
	BOOL flag=checklitebrowser(file);
	ifstream in(file);
	char buf[1000],num[8];
	BOOL added=FALSE; //ǉǂ
	
	if(flag) while(1)
	{
		in.getline(buffer,1000);//getline Iq͎菜
		if(in.gcount()==0) break;
		p=strstr(buffer,"http://");
		if(p==NULL) ;
		else
		{
			strncpy(buf,p,900);
			p=strchr(buf,'*');
			if(p==NULL) continue;
			*p=0;
			strncpy(num,buffer,6);
			p=strchr(num,':');
			if(p!=NULL) *p=0;

			p=strchr(buffer,'*')+1;
			addurl(buf,p,num,"");
			added=TRUE;
		}
		if(in.eof()) break;
	}
	else while(1)
	{
		in.getline(buffer,MAX_PATH);//getline Iq͎菜
		if(in.gcount()==0) break;
		p=strstr(buffer,"http://");
		if(p==NULL) ;
		else
		{
			if(CheckExistInUrl(buffer)==FALSE) 
			{
				addurl("","",buffer,"");
				added=TRUE;
			}
		}
		if(in.eof()) break;

	}
	return added;

}

void loaddirlocal(char *dir)
{
	ifstream in(dirdirfile);
	stockdir.num++;
	int n=stockdir.num;
	while(1)
	{
		in.getline(buffer,MAX_PATH);//getline Iq͎菜
		if(in.gcount()==0) break;
		n--;
		if(n<0) break;
	}
	if(n>=0)
	{
		stockdir.num=0;
	}
	else strcpy(dir,buffer);
}

void initlog(ofstream &log)
{
	SYSTEMTIME st;
	char jikan[16];
	char form[]="%04d/%02d/%02d";

	GetLocalTime(&st);
	wsprintf(
		jikan,
		form,
	
		st.wYear,
		st.wMonth,
		st.wDay
	);
	//log.open(logdirfile,ios::ate);
	//log<<endl<<jikan<<endl;
}


void openinit()
{
	ShellExecute(NULL, "open","notepad",initdirfile, NULL, SW_SHOW);
}

void openinitdir()
{
	ShellExecute(NULL, "open","explorer",cdir, NULL, SW_SHOW);
}

void initsessionnum()
{
	sessionNum=0;
}

int getsessionNum()
{
	return sessionNum;
}

void setseed(char *s)
{
	for(int i= 0; i<5;i++)
	{
		seed += ((unsigned char*)s)[i];
	}
	seed =seed/ 5 +1;
}

void getinitdirectory()
{
	GetCurrentDirectory(MAX_PATH,cdir);
}

void setdirfile(char *df,char *f)
{
	wsprintf(df,"%s\\%s",cdir,f);
}

//JgfBNg

void getini_cu()
{
	getinitdirectory();

	setdirfile(initdirfile,initfile);
	setdirfile(mainbrowserdirfile,mainbrowserfile);
	setdirfile(urldirfile,urlfile);
	setdirfile(searchdirfile,searchfile);
	setdirfile(urltimedirfile,urltimefile);
	setdirfile(dirdirfile,dirfile);
	setdirfile(hisdirfile,hisfile);
	setdirfile(winhisdirfile,winhisfile);
	setdirfile(treedirfile,treefile);
	setdirfile(bmtmpdirfile,bmtmpfile);
	setdirfile(helpdirfile,helpfile);
	setdirfile(clipdirfile,clipfile);
}

long getbookmarknum()
{
	long i=0;
	char buf[3000];
	ifstream in(urldirfile);
	while(1)
	{
		in.getline(buf,3000);
		if(in.gcount()==0) break;
		i++;
	}
	return i;
}

void resetvisittime(int num)
{
	ofstream ou(urltimedirfile,ios::binary|ios::ate);
	ou.seekp(num*timeitemsize,ios::beg);
	ou.write("000000000000  ",timeitemsize);
}

char visittime[16];

// XVԃt@C

void inittimefile()
{
	ofstream ou(urltimedirfile);
	long i=	getbookmarknum();
	for(long j=0;j<i;j++) ou<<"000000000000"<<"  ";
}

char* getvisittime()
{
	SYSTEMTIME st;
	char* jikan=visittime;
	char form[]="%04d%02d%02d%02d%02d";

	GetLocalTime(&st);
	wsprintf(
		jikan,
		form,
	
		st.wYear,
		st.wMonth,
		st.wDay,
		st.wHour,
		st.wMinute
	);
	return visittime;
}

void setvisittime()
{

	char* jikan =getvisittime();
	
	ofstream ou(urltimedirfile,ios::binary|ios::ate);
	ou.write(jikan,12);
	ou.write("  ",2);
}

char* setvisittime(int num,char*word)
{
	char* jikan =getvisittime();
	
	if(strlen(word)>0) strncpy(jikan,word,strlen(word));
	ofstream ou(urltimedirfile,ios::binary|ios::ate);
	ou.seekp(num*timeitemsize,ios::beg); 
	//ou.seekp(n*14,ios::cur); 
	ou.write(jikan,12);
	ou.write("  ",2);
	return jikan;
}


void delurlfromlist(int num)
{
	setvisittime(num,"*");
}

BOOL isHistory(char *file)
{
	return (strcmp(file,hisfile)==0);
}

BOOL isMainurl(char *file)
{
	return (strcmp(file,"bmedit main")==0);
}
BOOL isMemo(char *file)
{
	return (strncmp(file,"memofile",8)==0);
}

BOOL isBookmark(char *file)
{
	return (strcmp(file,urlfile)==0);
}

BOOL isSearch(char *file)
{
	return (strcmp(file,searchfile)==0);
}

void setlistbox(HWND &hdlg,UINT IDC)
{
	for(int i=0; i<sessionNum && i<namenummax ; i++)
	{
		SendDlgItemMessage(hdlg,IDC,LB_ADDSTRING,0,(LPARAM)namelist[i]);
	}
}

void getprofilepos( WINPOS *lpwinpos )
{
	lpwinpos->x = GetPrivateProfileInt(keywindow, "x",0,initdirfile);
	lpwinpos->y = GetPrivateProfileInt(keywindow, "y",0,initdirfile);
	lpwinpos->wx = GetPrivateProfileInt(keywindow, "wx",100,initdirfile);
	lpwinpos->wy = GetPrivateProfileInt(keywindow, "wy",100,initdirfile);
}

void getprofiledir()
{
	int i;
	i=0;
	localdirnum=0;
	while(1)
	{
		i++;
		wsprintf(buffer,"%d",i);
		GetPrivateProfileString(keydirlocal, buffer, "", buffer, MAX_PATH, initdirfile);
		if(strcmp(buffer,"")==0) break;
		AppendMenu(hLocalMenu,MF_STRING,localdirIDBASE+i-1,buffer);
		localdirnum++;
	}
}


// VfBNgۑ

void saveprofiledir(char *key, int *num, char *dir )
{
	BOOL flag=TRUE;
	char buff[MAX_PATH];
	if(dir[0]=='\\') return;
	//if(strcmp(dir,".")==0) return;

	int i=0;
	while(1)
	{
		i++;
		wsprintf(buff,"%d",i);
		GetPrivateProfileString(key, buff, "", buffer, MAX_PATH, initdirfile);
		if(strcmp(buffer,dir)==0 )
		{
			flag=FALSE;
			break;
		}
		if( strlen(buffer)==0 )
		{
			break;
		}
	}
	if (flag==FALSE ) return;
	(*num)++;
	wsprintf(buff,"%d",*num);
	WritePrivateProfileString(key, buff, dir, initdirfile);
}

void savelocaldir(char *dir)
{
	saveprofiledir(keydirlocal,&localdirnum,dir);
}

void saveremotedir(char *dir)
{
	saveprofiledir(keydirremote,&remotedirnum,dir);
}

void initcheckword()
{
	char chnum[4];
	for(int i=0;i<maxcheckmax;i++)
	{
		wsprintf(chnum,"%d",i);
		GetPrivateProfileString("wintitlekey", chnum,"", checkword[i], sizeof(checkword[i]), initdirfile);
		if(checkword[i][0]==0)
		{
			maxcheck=i;
			break;
		}
	}
}

void MyGetInitialData(HWND hwnd, WINPOS *lpwinpos)
{
	char buffer[MAX_PATH];
	getini_cu();
	DWORD size=getfilesize(urldirfile);
	FileBuffer =(char*)malloc(size);
	ifstream in(urldirfile, ios::binary | ios::nocreate);
	if(in)in.read(FileBuffer,size);
	in.close();

	dontoverwrite =FALSE;//㏑
	autoedit =FALSE;//ҏW@㏑Ȃ ios::
	getprofilepos(lpwinpos);
	getprofiledir();
	timerUrl[0]=0;
	in.open(urltimedirfile,ios::nocreate);
	if(!in) inittimefile();//ԃt@CȂꍇ̓[ŃZbg
	GetPrivateProfileString(keydirlocal, "favorites", "", favorites, MAX_PATH, initdirfile);
	if(strlen(favorites)==0) wsprintf(favorites,"%s\\favorites",getenv("winbootdir"));
	log(initdirfile);
	wsprintf(mainposition,"home");
	GetPrivateProfileString(keywindow, "startpage", "http://www.google.com/", startpage, MAX_PATH, initdirfile);
	GetPrivateProfileString(keywindow,"mybrowser", "off", buffer, MAX_PATH, initdirfile);
	browserflag= (strcmp(buffer,"off")==0)  ? FALSE : TRUE;
	GetPrivateProfileString(keywindow,"startbrowser", "off", buffer, MAX_PATH, initdirfile);
	startbrowser= (strcmp(buffer,"off")==0)  ? FALSE : TRUE;
	GetPrivateProfileString(keywindow,"singleclick", "off", buffer, MAX_PATH, initdirfile);
	singleclick= (strcmp(buffer,"off")==0)  ? FALSE : TRUE;
	GetPrivateProfileString(keywindow,"TitleSave", "off", buffer, MAX_PATH, initdirfile);
	titlesave= (strcmp(buffer,"off")==0)  ? FALSE : TRUE;
	GetPrivateProfileString(keywindow,"netmode", "off", buffer, MAX_PATH, initdirfile);
	netflag= (strcmp(buffer,"off")==0)  ? FALSE : TRUE;
	GetPrivateProfileString(keywindow,"urldelim", "", buffer, MAX_PATH, initdirfile);
	if(strlen(buffer)>0) strncat(UrlEndDelim,buffer, UrlEndDelimMax -strlen(UrlEndDelim));
	myBM.SetUrlfile(urldirfile);
	myBM.SetTimefile(urltimedirfile);
	myBM.checknum();
	Browser.setwnd(hwnd);
	Soft.setwnd(hwnd);
	Browser.setkey(keybrowser,keybrowsername);
	Soft.setkey(keysoft,keysoftname);
	FFile.setkey(keyffile,keyffilename);
	FixedUrl.setkey(keyfixedurl,keyfixedbrowser);
	FastUrl.setkey(keyfasturl,"");
	int num = GetPrivateProfileInt(keywindow,"mainbrowser",0,mainbrowserdirfile);
	setbrowser(num);
	readksize = GetPrivateProfileInt(keywindow,"readksize",0,initdirfile);
	initcheckword();

	return;
}




void MySetInitialData(WINPOS *lpwinpos)
{
	char buffer[MAX_INFO];
	//itoa()
	wsprintf(buffer,"%d",lpwinpos->x);
	WritePrivateProfileString(keywindow, "x", buffer, initdirfile);
	wsprintf(buffer,"%d",lpwinpos->y);
	WritePrivateProfileString(keywindow, "y", buffer, initdirfile);
	wsprintf(buffer,"%d",lpwinpos->wx);
	WritePrivateProfileString(keywindow, "wx", buffer, initdirfile);
	wsprintf(buffer,"%d",lpwinpos->wy);
	WritePrivateProfileString(keywindow, "wy", buffer, initdirfile);

	wsprintf(buffer,"%d",browsernum);
	WritePrivateProfileString(keywindow, "mainbrowser", buffer, mainbrowserdirfile);
	if(FileBuffer!=NULL) free(FileBuffer);

	return;
}


int initcolumnsize(int n)
{
	char name[numlen+6];

	wsprintf(name,"column%d",n);
	return GetPrivateProfileInt(keywindow, name, 0, initdirfile);
	log("column");
	log(initdirfile);
}

void saveinitcolumnsize(int n, int size)
{
	char name[numlen+6];
	char buffer[MAX_INFO];
	//itoa()
	wsprintf(name,"column%d",n);
	wsprintf(buffer,"%d",size);
	WritePrivateProfileString(keywindow, name, buffer, initdirfile);
}


void getbrowsername(char *buffer,char *name,char *path)
{
	if(strlen(name)>0) strcpy(buffer,name);
	else _splitpath(path,NULL,NULL,buffer,NULL);
}


BOOL initlist::add(char *path0)
{
	char buffer[100];
	_splitpath(path0,NULL,NULL,buffer,NULL);
	return add(path0,buffer);
}

BOOL initlist::add(char *path0, char *name0)
{
	if(strlen(path0)==0) return FALSE;
	char chnum[numlen];
	int i=getcount();//ݓo^Ă鐔
	wsprintf(chnum,"%d",i+1);
	WritePrivateProfileString(keypath, chnum, path0, initdirfile);
	WritePrivateProfileString(keyname, chnum, name0, initdirfile);
	MessageBox(hwnd, "ǉ܂", keyname, MB_OK);
	return TRUE;
}

//uEUǉ
void addbrowser(char *path, char *name)
{
	if(strlen(path)==0) return;
	char chnum[numlen];
	int i=getbrowsercount();//ݓo^ĂuEU̐
	wsprintf(chnum,"%d",i+1);
	getbrowsername(buffer,name,path);
	WritePrivateProfileString(keybrowser, chnum, path, initdirfile);
	WritePrivateProfileString(keybrowsername, chnum, name, initdirfile);
}

//
int getcount(char *key)
{
	char name[4];
	static char chnum[numlen];
	for (int i=0;i<initcountmax;i++)
	{
		wsprintf(chnum,"%d",i+1);
		GetPrivateProfileString(key,chnum, "", name, 4, initdirfile);
		if(name[0]==0) break;
	}
	return i;
}

//uEU̐
int getbrowsercount()
{
	
	return getcount(keybrowser);
}

//uEŨtpX
char* getlistfrominit(char *key, char *buffer, int num)
{
	static char chnum[numlen],name[MAX_PATH];
	wsprintf(chnum,"%d",num);
	GetPrivateProfileString(key,chnum, "", name, MAX_PATH, initdirfile);
	if(buffer!=NULL) strcpy(buffer,name);
	return name;
}

// uEU̖O
char* getbrowsernamefrominit(char *buffer, int num)
{
	char *ans =getlistfrominit(keybrowsername, buffer, num);
	if(strlen(ans)==0) 
	{
		strcpy(ans,"W");
		strcpy(buffer,ans);
	}
	return ans;
}
// uEŨtpX
char* getbrowserfrominit(char *buffer, int num)
{
	return getlistfrominit(keybrowser, buffer, num);
}

// initlist class
// ݒt@CuEUAԁ{OAԂȂǂ̃f[^荞ނ
char *initlist::getpath(int num)
{
	getlistfrominit(keypath, path, num);
	return path;
}


char *initlist::getname(int num)
{
	getlistfrominit(keyname, name, num);
	return name;
}


// pathTAԍԂ
int initlist::searchpath(char *p)
{
	int ans =0;
	static char chnum[numlen];
	getcount();
	for (int i=0;i<count;i++)
	{
		wsprintf(chnum,"%d",i+1);
		GetPrivateProfileString(keypath,chnum, "", path, sizeof(path)-1, initdirfile);
		if(path[0]==0) continue;
		if(strcmp(p,path)==0) 
		{
			ans=i+1;
			break;
		}
	}
	return ans;
}


int initlist::getcount()
{
	count = ::getcount(keypath);
	return count;
}

void initlist::initmenu()
{
	if(getcount()<menubase) menubase=0;
	int menumax=40;
	char wo[MAX_PATH];
	for(int i=0 ;i<menumax;i++)
	{
		RemoveMenu(hmenu,0, MF_BYPOSITION);
	}
	for(i=menumax ;i>0;i--)
	{
		wsprintf(wo,"%s",getname(i+menubase));
		if(strlen(wo)==0) wsprintf(wo,"%s",getpath(i+menubase));
		if(strlen(wo)==0) continue;
		InsertMenu(hmenu,0, MF_BYPOSITION, baseID +i , wo);
	}
	InsertMenu(hmenu,0, MF_BYPOSITION, baseID , "W");
}


//--------------------------------------------------------------
// bmurl class ֘A

BOOL UrlInData(char *dat)
{
	BOOL ans=FALSE;
	if (strstr(dat,"http://")!=NULL) ans=TRUE;
	return ans;
}


// url܂ލsԂ

int geturlitemnum(char *file)
{
	int num;
	ifstream in(file,ios::nocreate);
	if(!in) return 0;
	const int MAX_DAT=3000;//K
	char szBuf[MAX_PATH],buffer[MAX_DAT];
	while(!in.eof())
	{
		memset(buffer,0,MAX_DAT);
		in.getline(buffer,MAX_DAT-2);
		if( UrlInData(buffer) ) num++;
	}
	return num;
}

int gettimeitemnum(char *file)
{
	return getfilesize(file)/timeitemsize;
}


void bmurl::SetUrlfile(char *name)
{
	wsprintf(urlfile,"%s",name);
}

void bmurl::SetTimefile(char *name)
{
	wsprintf(timefile,"%s",name);
}

void bmurl::checknum()
{
	urlnum=geturlitemnum(this->urlfile);
	timenum=gettimeitemnum(this->timefile) ;
	if( urlnum > timenum ) resetvisittime(urlnum);
}


char *gettmp()
{
	return bmtmpdirfile;
}

void CutWordByKey(char *word, char key)
{
	char *en;
	en=strchr(word,key);if (en!=NULL) *en=0;
}

void urlendcheck(char *w)
{
	for(int i=0;i<strlen(UrlEndDelim);i++)
	CutWordByKey(w,UrlEndDelim[i]);
}

// url title@ǂݎAtmpt@Cɏo
// readsize Ȍꍇ͑Sǂݎ
// ȊO͌낾
void readbinbykey(char *file, char *key, int mode, int readsize)
{
	char buffer[10001],url[10001],title[201];;
	char *p, *en,*pp;
	BOOL flag;
	BOOL htm=FALSE;

	if(checkExt(file,"htm") || checkExt(file,"html")) htm=TRUE;

	int filesize=getfilesize(file);
	ifstream in(file, ios::binary | ios::nocreate);
	int m;
	if(mode==0) m = ios::trunc;//ios::beg
	if(mode==1) m = ios::ate;//ǉ
	ofstream ou(bmtmpdirfile, m);
	if(readsize!=0) in.seekg(-min(readsize*1000,filesize), ios::end);
	if(!in) return;
	while(in )
	{
		memset(buffer,0,10001);
		in.read(buffer,10000);
		flag=TRUE;
		p =buffer;
		for(int i=0;i<10000-strlen(key);i++)
		{
			if(strncmp(p+i,key,strlen(key))!=0) continue;
			memset(url,0,10001);
			memset(title,0,201);
			strcpy(url,p+i);
			urlendcheck(url);
			if(htm) pp =strchr(p+i,'>');
			else pp =p+i+strlen(url);
			if(pp!=NULL && strlen(pp)>0) 
			{
				pp++;
				strncpy(title,pp,200);
				en=strchr(title,'<');
				if(en!=NULL) *en=0;
			}
			else title[0]=0;
			urlendcheck(title);
			ou<<url<<'\t'<<title<<endl;
		}
		in.seekg(-strlen(key), ios::cur);
	}
}

// tmp fileURLSo
// gqhtm(html)Ȃ^Cg

void readurlfrombin(char *file)
{
	char key[]="http";
	readbinbykey(file, "http",0,readksize);
	readbinbykey(file, "ftp",1,readksize);
}
