#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include "resource.h"
#include "hwnd.h"
#include "initial.h"
#include "file.h"
#include "browse.h"
#include "status.h"
#include "bmedit.h"

int browsermenumax=10;

BOOL isurl(char *url)
{
	return (strncmp(url,"http",4)==0 ||strncmp(url,"ftp",3)==0 );
}

void geturlfromshortcut(char *sc, char *url)
{
	char buffer[MAX_URL];
	GetCurrentDirectory(MAX_PATH,buffer);
	strcat(buffer,"\\");
	strcat(buffer,sc);
	GetPrivateProfileString("InternetShortcut", "URL", "http://", url, MAX_URL, buffer);
}

void seturltoshortcut(char *sc, char *url)
{
	char buffer[MAX_URL];
	GetCurrentDirectory(MAX_PATH,buffer);
	strcat(buffer,"\\");
	strcat(buffer,sc);
	WritePrivateProfileString("InternetShortcut", "URL", url, buffer);
}

void myexec(HWND hwnd, char* lpOperation, char* lpFile, char* lpParameters, char* lpDirectory, INT nShowCmd)
{
	char buffer[MAX_URL];
	if(browserflag )
	{
		if(checkExt(lpFile,"url"))
		{
			geturlfromshortcut(lpFile, buffer);
			ShellExecute(hwnd, lpOperation, browser, buffer, lpDirectory, nShowCmd);
		}
		else if(isurl(lpFile) )
		{
			ShellExecute(hwnd, lpOperation, browser, lpFile, lpDirectory, nShowCmd);
		}
		setstatusonly(ST_SOFT, browser);
	}
	else
	{
		ShellExecute(hwnd, lpOperation, lpFile, lpParameters, lpDirectory, nShowCmd);
		setstatusonly(ST_SOFT, lpFile);
	}
}


void myexecDclk(HWND hwnd, char* lpOperation, char* lpFile, char* lpParameters, char* lpDirectory, INT nShowCmd)
{
	if(isurl(lpFile) ) 
	{
		int i=FixedUrl.searchpath(lpFile);
		if(i==0)
		{
			myexec(hwnd, lpOperation, lpFile, lpParameters, lpDirectory, nShowCmd);
		}
		else
		{
			setbrowser(FixedUrl.getname(i));
			myexec(hwnd, lpOperation, lpFile, lpParameters, lpDirectory, nShowCmd);
			browserback();
		}
	}
	else myexec(hwnd, lpOperation, lpFile, lpParameters, lpDirectory, nShowCmd);
}

void open(char *file)
{
	ShellExecute(NULL, "open",file, NULL, NULL, SW_SHOW);
}

void setbrowser(char *path)
{
	if(strlen(path)==0) return;
	if(!exist(path)) return;
	strcpy(browser,path);
	browserflag =TRUE;
	browsernumback =browsernum;
}

void browserplus()
{
	browsernum++;
	setbrowser(browsernum);
}
void browserminus()
{
	browsernum--;
	setbrowser(browsernum);
}


void CheckBrowserMenu(int num)
{
	for(int i=0;i<browsermenumax;i++)
		CheckMenuItem(hBrowserMenu, IDM_BROWSER_0+i, MF_UNCHECKED);
	if(num<browsermenumax) CheckMenuItem(hBrowserMenu, IDM_BROWSER_0+num, MF_CHECKED);
}

void addbrowsercurrent(char *name)
{
	char path[MAX_PATH],file[MAX_PATH*2];
	GetCurrentDirectory(MAX_PATH, path);
	wsprintf(file,"%s\\%s", path, name);
	addbrowser(file,"");
}

// ݒt@CnumԖڂ̃uEU[ǂ

BOOL setbrowser(int num)
{
	BOOL ans=TRUE;
	if(num<0 || num>getbrowsercount()) ans=FALSE;
	if(num<0) num=getbrowsercount();
	browsernumback =browsernum;
	char buffer[MAX_PATH];
	getbrowserfrominit(buffer,num);
	browsernum =num;
	browserflag=TRUE;
	strcpy(browser,buffer);
	if(strlen(browser)==0) 
	{
		browserflag=FALSE;
		browsernum =0;
		ans=FALSE;
	}
	getbrowsernamefrominit(browsername,num);
	CheckBrowserMenu(browsernum);
	resettitle();
	return ans;
}



int browsernumpush()
{
	browsernumback=browsernum;
	return browsernum;
}
int browsernumpop()
{
	browsernum=browsernumback;
	return browsernum;
}
//ÕuEUɖ߂
void browserback()
{
	browsernumpop();
	setbrowser(browsernum);
}